DEFINT A-Z
'$DYNAMIC

COMMON SHARED maxfps, ts, gamemode, realtimer!, anmcounter, gameplay
COMMON SHARED quitgame, curlevel

CONST enginever = 8
CONST inmenu = 1, ingame = 2
CONST lookup = 4, lookdown = 5
'CONST drawpage = 0, backdroppage = 0, menupage = 0   ' delete this line
CONST drawpage = 1, menupage = 2, backdroppage = 3  ' use this one
CONST moving = 0, shooting = 1, switching = 2, dying = 3, teleporting = 4
CONST climbing = 5, pogo = 6, hanging = 7, hangclimb = 8
CONST idle = 9
CONST running = 1, paused = 2

DECLARE SUB AllocXMS ()
DECLARE SUB DeallocXMS ()
DECLARE SUB DebugLog (t$)
DECLARE SUB DoInput ()
DECLARE SUB DoTimers ()
DECLARE SUB ErrorHandlerSub (e)
DECLARE SUB IncreaseIdleTime ()
DECLARE SUB InitEngine ()
DECLARE SUB LoadLevel ()
DECLARE SUB MainLoop ()
DECLARE SUB NextLevel ()
DECLARE SUB SetPalette ()

TYPE coordinate
 x AS SINGLE
 y AS SINGLE
END TYPE

TYPE hues
 red AS INTEGER
 grn AS INTEGER
 blu AS INTEGER
END TYPE

TYPE intcoordinate
 x AS INTEGER
 y AS INTEGER
END TYPE

TYPE playertype
 x AS SINGLE
 y AS SINGLE
 xv AS SINGLE
 yv AS SINGLE
 xdir AS INTEGER
 xmax AS SINGLE
 ymax AS SINGLE
 sframe AS LONG
 eframe AS LONG
 frame AS LONG
 delay AS INTEGER
 xsize AS INTEGER
 ysize AS INTEGER
 txsize AS INTEGER
 tysize AS INTEGER
 onground AS INTEGER
 onslope AS INTEGER     ' player is standing on an incline
 adelay AS INTEGER
 canjump AS INTEGER
 jumpheight AS SINGLE
 score AS LONG            ' scores.bi, items.bi
 ammo  AS INTEGER         ' scores.bi, weapon.bi
 drops AS INTEGER         ' items.bi
 lives AS INTEGER         ' scores.bi
 reload AS INTEGER        ' time to wait for reload
 shooting AS INTEGER      ' time to display shooting frame
 shootingframe AS LONG    ' shooting frame to show
 aim AS INTEGER           ' aiming to shoot up or down
 action AS INTEGER        ' moving, shooting, climbing, flipping switch, pogo
 actiontime AS INTEGER    ' time left to complete action
 frozen AS INTEGER        ' cant move left or right
 usingportal AS INTEGER   ' if walking into a portal find destination x,y
 changeaction AS INTEGER  ' so cant switch between actions too fast
 holdingjump AS INTEGER   ' player is actively jumping up
 stoppedjump AS INTEGER   ' no longer holding the jump button
 onlift AS INTEGER        ' lift currently standing on
 idletime AS INTEGER      ' frames player hasnt pressed a key
END TYPE

COMMON SHARED player() AS playertype, ClipPoint() AS coordinate
COMMON SHARED scr(), file() AS STRING * 12
COMMON SHARED biti() AS INTEGER, bitl() AS LONG, pal() AS hues
COMMON SHARED pframe() AS LONG, fsize() AS intcoordinate

